#include "resizer.h"

/*
Source:
Taken from:

'Zur uebung aus Numerische Mathematik'
Interpolation im Wintersemester 1998/99.

Team:
Betreuer: 
Reinhold Kainhofer
Karl Perktold
Philip Ohnewein                                                         
A. Leuprecht
Johannes Hatzl
Stefan Pock 

Ported from C++ to C by Jan Panteltje.
*/


/* 
....................................................
.                   Lagrange                       .
....................................................*/

#define MAXSUPPORTS	1024
#define bool int
#define false 0
#define true 1

double Supports[MAXSUPPORTS];
double SupportingValues[MAXSUPPORTS];
//Beschreibt hier die Koeffizienten des Polynoms
double Coefficients[MAXSUPPORTS];
int n;


double ChangeCoefficient(int m, double x)
{

// Koeffizienten sollen nicht geaendert werden koennen
return 0;
} /* end function ChangeCoefficient */


bool ChangeSupportingValue(int m, double y)
{
if( (m <= n) && (m >= 0) ) SupportingValues[m] = y;
return true;
} /* end function ChangeSupportingValue */


double GetSupportingValue(int i)
{
if(i >= 0 && i < n) return SupportingValues[i];

return 0;
} /* end function GetSupportingValue */


InitLagrange()
{
int i;

Supports[0] = 0;
SupportingValues[0] = 0;
//for(i = 0; i < MAXSUPPORTS; i++)
//	{
//	Coefficients[i] = 1.0;
//	}

Coefficients[0] = 1.0;
n = 0;
} /* end function Lagrange */


// int m has to be processed.....
int InsertSupport(double x, double y, int m)
{
bool AlreadyThere = false;
int i, oldindex;
double coefftmp;

if(debug_flag)
	{
	fprintf(stderr,\
	"resizer-yuv(): InsertSupport(): x=%.2f y=%.2f m=%d\n",\
	x, y, m);
	fprintf(stderr, "n=%d\n", n);
	}

for(i = 0; i < n; i++) 
	{
	if(Supports[i] == x) 
		{ 
		AlreadyThere = true; 
		oldindex = i; 
		}
	}
if(AlreadyThere)
	{
	// Value already used,so just change the y value:
	ChangeSupportingValue(oldindex, y);
	return oldindex;
	}
else
	{
	/*
	We have to insert the new (x, y) at the appropriate position and
	recalculate the Lambdas (Coefficients):
	*/
	for(i = 0; i < n; i++) Coefficients[i] /= (Supports[i] - x);
	if(n > 0)
		{
		// calculate the new coefficient
		/*
		Coefficients[n] = 1;
		for(i = 0; i <= n - 1; i++) Coefficients[n] /= (x - Supports[i]);
		*/

		// or: 
		coefftmp = 0;
		for (i = 0; i < n; i++) coefftmp -= Coefficients[i]; 
		}
	else
		{
		coefftmp = 1;
		}

	i = n - 1;
	while( (Supports[i] > x) && (i >= 0))
		{
		Supports[i + 1] = Supports[i];
		SupportingValues[i + 1] = SupportingValues[i];
		Coefficients[i + 1] = Coefficients[i];

		i--;
		}

	Supports[i + 1] = x;
	SupportingValues[i + 1] = y;
	Coefficients[i + 1] = coefftmp;

//fprintf(stderr,\
//"Supports[i+1]=%.2f SupportingValues[i+1]=%.2f Coefficients[i+1]=%.2f\n",\
//Supports[i + 1], SupportingValues[i + 1], Coefficients[i + 1]);

	n++;

	return i + 1;
	}
} /* end function InsertSupport */


double get_coefficient(int x)
{
fprintf(stderr, "WAS Coefficients[x]=%.2f\n", Coefficients[x]);

return Coefficients[x];
}

// Change the x value for the m-th support:
bool ChangeSupport(int m, double x)
{
double old = GetSupportingValue(m);

DeleteSupport(m);
InsertSupport(x, old, m);

return true; 
} /* end function ChangeSupport */


// Get the value of the Lagrange Interpolating polynom at the position x:
double Evaluate(double x)
{
double Weights[MAXSUPPORTS];
int i;
double Nenner, Zaehler, P;

for(i = 0; i < n; i++)
	{
	//Otherwise we have a division by 0
	if (Supports[i] == x)  return SupportingValues[i];

	Weights[i] = Coefficients[i] / (x - Supports[i]);
	}
Nenner = 0;
Zaehler = 0;
for(i = 0; i < n; i++)
	{
	Zaehler += (Weights[i] * SupportingValues[i]);
	Nenner += Weights[i];
	}
if(Nenner == 0) Nenner = 0.000000001;
P = Zaehler / Nenner;

return P;
} /* end function Evaluate */


bool DeleteSupport(int m)
{
double oldx;
int i;

if( (m >= 0) && (m < n) )
	{
	n--;
	oldx = Supports[m];
	for(i = m; i < n; i++)
		{
		Supports[i] = Supports[i + 1];
		SupportingValues[i]=SupportingValues[i + 1];
		Coefficients[i] = Coefficients[i + 1];
		}

	for(i = 0; i < n; i++) Coefficients[i] *= (Supports[i] - oldx);
	return true;
	}
else
	{
	return false;
	}
}/* end function DeleteSupport */


bool CalcCoefficients()
{
int i, k;

Coefficients[0] = 1;

for(k = 1; k < n; k++)
	{
	for(i = 0; i < k; i++)
		{
		Coefficients[i] /= (Supports[i] - Supports[k]);
		}

	Coefficients[k] = 0;

	for(i = 0; i < k; i++) Coefficients[k] -= Coefficients[i];
	}

return true;
} /* end function CalcCoefficients */


