          Manual resizer-yuv-0.4 for use with mjpeg tools.

                  Copyright (c) 2002 Jan Panteltje

What it is:
low pass filter followed by resizer for video streams.
Uses fft and reverse fft package fftw-2.1.3.tar.gz library from:
http://www.fftw.org/
Use the version best suited for your processor.
mjpegtools can be found at:
http://mjpeg.sourceforge.net/

resizer-yuv -h
shows command line options.

What it does:
This resizes 720x576 DVB-s (digital satellite PAL) video to 352x576 CVD
(China Video Disk, also known as D/2 DVD half resolution standard),
without the artefacts (saw tooth like effects) that yuvscaler causes. 
OTHER FORMATS ARE NOT SUPPORTED AT THIS MOMENT, and may cause severe
artefacts.

How it does it:
A n order low pass filter using 1 - exp(-x^2 / b) is used before the 
resizing (horizontal only), to remove any frequency components above
the sample frequency / 2, thus preventing artefacts.
Some artefact are introduced by the FTT followed by reverse FFT.

Filter coefficients are calculated so the frequency curve is at 10%
at the f / 2 point, and 75% at a 10 % lower point.
The -v command line flag will print out amplitude in dB versus frequency
in MHz to stderr.
You can redirect stderr with 2> loq.txt

Note for programmers:
If you change any filter coefficients in the source, make sure spectral
component zero is always multiplied by 1.000, this is the DC component.
An error in the DC component for U and V will cause the color to change!
(produces a false color signal), in Y will cause the brightness to change.
End note for programmers.

Advantages:
Artifacts removed are especially those in striped clothing, patterns in a
tie, etc (high frequency aliasing).

Disadvantages:
Artifacts introduced are vertical edges at low frequency objects, for
example large surfaces of constant luminance or color.
In general however on many materials resizer-yuv looks better then yuvscaler.
Run a test and compare what you like most, and use that.

When can you see the benefits:
This program was designed to make better CVD on CD-R disk, played in a 
standalone DVD player.
In such a case, a TV set is normally used for display and the display is
truely interlaced.
This already reduces any distortions in vertical direction.
If you use for example a viewer on a PC, with interlace on, the distortion
introduced by this deinterlace may alreay make the improvement gained by
removing aliasing in the horizontal direction invisible.

So the use of rescaler-yuv is probably more effective when really making
CVD CD-R  that will play on a standalone DVD player, not in a PC application.

References:
I took this code from transcode bbmpeg resize.c, and gave it an yuv
interface conform mjpegtools.
Then I added a low pass before the resizer using fft followed by reverse
fft.

Optimization:
resizer-yuv will run tests to find out the best fft algo if you specify
the -m flag on the command line.

License:
This is Linux software.
released under the GPL.


To compile and install:
Type 
make

If the linker complains about 'getline' not found, then perhaps you
do not have GNU libc, try commenting out at the end of resizer.h:
//#define NO_GNU_C
and type make again.

make install
make install.man

resizer-yuv -h
shows some command line options.


To use:
resizer-yuv is designed to be used with the mjpeg tools package, located at
http://mjpeg.sourceforge.net/

Example script, to convert 720x576 DVB-s satellite PAL to CVD 352x576:
(use -s in mpeg2dec only on multiplexed streams).

cat $1 | \
mpeg2dec \
-s \
-o YUV \
| \
./resizer-yuv \
-x 352 \
-y 576 \
-v \
| \
mpeg2enc \
--video-bitrate 2500 \
--interlace-mode 1 \
--video-buffer 230 \
--min-gop-size 6 \
--max-gop-size 15 \
--reduction-4x4 1 \
--reduction-2x2 1 \
--quantisation 5 \
--frame-rate 3 \
--aspect 2 \
--format 3 \
--video-norm p \
--playback-field-order t \
-o ./test-cvd.mpg


Homepage of resizer-yuv:
http://www.home.zonnet.nl/panteltje/subtitles/

Jan Panteltje
panteltje@yahoo.com


Test script, to see the artefacts introduced in a color bar:

y4mcolorbars -F 50:1  -I b -n 100 -W 720 -H 576 \
| \
resizer-yuv -x 352 -y 576 \
|
mpeg2enc \
--video-bitrate 2500 \
--interlace-mode 1 \
--video-buffer 230 \
--min-gop-size 6 \
--max-gop-size 15 \
--reduction-4x4 1 \
--reduction-2x2 1 \
--quantisation 3 \
--frame-rate 3 \
--aspect 2 \
--format 3 \
--video-norm p \
--playback-field-order t \
-o ./q1.mpg

xine -pgfhq q1.mpg

